/* 
 * Display a modeline giving some stats about the current qiz-file
 * 
 */

#include "modeline.h"
#include "cconvert.h"
#include <stdio.h>
#include <string.h>

void modeline(byte  modified,
	      char  filename[],
	      word  n[2],	       /* number of entries */
	      word  n_tested[2],       /* number of tested entries */
	      word  n_pos[2],	       /* of cards known */
	      word  n_neg[2],	       /* number of failed cards */
	      char  lang[2][MAX_PHRASE_LEN],
	      word  the_coding_system,
	      byte  current_language_test
	      )
{
  int  l;
  int  i;

  /* only print something if file is loaded */
  if (filename[0] != 0 && filename[0] != '*') {
    if (strlen(filename) > 14) {
      l = strlen(filename) - 14;
    } else {
      l = 0;
    }
    /* Find out, if path is absolute, return only file */
    for (i=strlen(filename); i>=l; i--) {
#ifdef unix
      if (filename[i] == '/') {l=i+1;}
#else
      if (filename[i] == '\\') {l=i+1;}
#endif
    }
/*3456789 123456789 123456789 123456789 123456789 123456789 1234
>**-(latin-1    ) polsku78.qi    --nl 1( t1% t1%)/nl 2( t2% t2%)
 */
    printf("%c%2s-(%11.11s) %14.14s --%4d(%3d%%%3d%%)/%4d(%3d%%%3d%%)",
	   (current_language_test == 0?'>':'<'),
	   (modified?"**":"--"),
	   cp_name[the_coding_system],
	   &(filename[l]),
	   n[0], (n[0]>0?((n_tested[0]-n_neg[0]-n_pos[0])*100)/n[0]:0),
		 (n_neg[0]+n_pos[0]>0?n_pos[0]*100/(n_pos[0]+n_neg[0]):0),
	   n[1], (n[1]>0?((n_tested[1]-n_neg[1]-n_pos[1])*100)/n[1]:0),
		 (n_neg[1]+n_pos[1]>0?n_pos[1]*100/(n_pos[1]+n_neg[1]):0)
	   );
  }				       /* end if filename */
}
